#!/bin/sh

curl -LO http://ftp.acc.umu.se/debian-cd/12.5.0/amd64/iso-cd/debian-12.5.0-amd64-netinst.iso
xorriso -osirrox on -indev debian-12.5.0-amd64-netinst.iso -extract / ./isofiles
chmod +w -R isofiles/
gunzip ./isofiles/install.amd/initrd.gz
echo preseed.cfg | cpio -H newc -o -A -F isofiles/install.amd/initrd
cp bootloader-configs/*.cfg isofiles/isolinux
gzip isofiles/install.amd/initrd
cd isofiles
# Execute the md5sum generation in a separated shell instance, because it returns a
# warning (file system loop) that makes the CI job error out
sh -c "find -follow -type f ! -name md5sum.txt -print0 | xargs -0 md5sum > md5sum.txt"
cd ..
chmod -w -R isofiles/
genisoimage -r -J -b isolinux/isolinux.bin -c isolinux/boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table -o halis-debian-12.5.0-amd64.iso isofiles
