#!/bin/sh

RASPIOS_IMG=2024-03-15-raspios-bookworm-arm64-lite.img

echo "Fetching image"
curl -O https://downloads.raspberrypi.com/raspios_lite_arm64/images/raspios_lite_arm64-2024-03-15/2024-03-15-raspios-bookworm-arm64-lite.img.xz

echo "Uncompressing image"
unxz $RASPIOS_IMG.xz

OFFSET_IMG=$(file $RASPIOS_IMG | cut -d';' -f3 | cut -d',' -f8 | cut -d' ' -f3)

mkdir -p mnt

echo "Mounting second partition"
sudo mount $RASPIOS_IMG -o offset=$((512*$OFFSET_IMG)) mnt

echo "Mounting necessary directories"
sudo mount -o bind /run mnt/run
sudo mount --rbind /dev mnt/dev

echo "Chroot into partition to start edition"
sudo chroot mnt /bin/sh <<"EOT"

/usr/sbin/usermod -l creator pi
/usr/sbin/usermod -d /home/creator -m creator
sed -i 's/creator:\*:/creator:\$6\$saltsalt\$EamwjkVXAe1WqiTTXuzgsmljl5cpVewMLH3xl8TdvQ\/V4S9e30upeNz2bdLkG5\.H71TCEso5Nl0jpyZRx7xy6\/:/g' /etc/shadow
sudo -u creator mkdir -p -m 700 /home/creator/.ssh
sudo -u creator sh -c 'echo "ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIDYsz4jdyzf9UcJ8eEavVmi+DNYE3ioeJBfTlVMw7Vsb tanguy@Diogenes" > /home/creator/.ssh/authorized_keys'
chmod 600 /home/creator/.ssh/authorized_keys
sed -i -E 's/#?PasswordAuthentication yes/PasswordAuthentication no/' /etc/ssh/sshd_config
systemctl enable ssh
echo "kenoma" > /etc/hostname
echo "IP: \4" >> /etc/issue
EOT

echo "Unmounting second partition"
sudo umount mnt -R

CORE_COUNT=$((`nproc`-1))

echo "Compressing resulting image"
xz -T$CORE_COUNT $RASPIOS_IMG

cp $RASPIOS_IMG.xz halis-debian-11.6.0-amd64.img.xz
